/*==================================================================================================

Copyright (c) 2007 UGS
Unpublished - All rights reserved

====================================================================================================
File description:

Filename: setIntOperationDispatcher.hxx
Module  : extensionframework

This is the root interface class of the setIntOperationDispatcher. It contains of all the generic methods
for setIntOperationDispatcher that can be reused by the derived classes.

====================================================================================================
Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setIntOperationDispatcher_HXX
#define setIntOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setIntOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setIntOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
public:
    setIntOperationDispatcher();
    virtual ~setIntOperationDispatcher();
    static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setIntPreConditions( Teamcenter::BusinessObject* obj, const int intValue, const bool isNull ) const;
    void setIntPreActions( Teamcenter::BusinessObject* obj, const int intValue, const bool isNull ) const;
    void setIntBaseAction( Teamcenter::BusinessObject* obj, const int intValue, const bool isNull ) const;
    void setIntPostActions( Teamcenter::BusinessObject* obj, const int intValue, const bool isNull ) const;

    // Project 011450 changes
    void setIntPreConditions( METHOD_message_t* msgData, const int intValue, const logical isNull ) const;
    void setIntPreActions( METHOD_message_t* msgData, const int intValue, const logical isNull ) const;
    void setIntPostActions( METHOD_message_t* msgData, const int intValue, const logical isNull ) const;
    void setIntBaseAction( METHOD_message_t* msgData, const int intValue, const logical isNull ) const;

    void setInt( Teamcenter::BusinessObject* obj, const int intValue, const bool isNull ) const;

    void execute(Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setIntOperationDispatcher_HXX
